package providers

import "git.tebibyte.media/sashakoshka/step"
import fpos       "git.tebibyte.media/sashakoshka/step/providers/os"
import fphttp     "git.tebibyte.media/sashakoshka/step/providers/http"
import fppath     "git.tebibyte.media/sashakoshka/step/providers/path"
import fpmime     "git.tebibyte.media/sashakoshka/step/providers/mime"
import fpslice    "git.tebibyte.media/sashakoshka/step/providers/slice"
import fpsprig    "git.tebibyte.media/sashakoshka/step/providers/sprig"
import fpimport   "git.tebibyte.media/sashakoshka/step/providers/import"
import fpmarkdown "git.tebibyte.media/sashakoshka/step/providers/markdown"

// All returns a slice of all providers defined in sub-packages.
func All () []step.FuncProvider {
	return []step.FuncProvider {
		new(fpos.Provider),
		new(fphttp.Provider),
		new(fppath.Provider),
		new(fpmime.Provider),
		new(fpslice.Provider),
		new(fpsprig.Provider),
		new(fpimport.Provider),
		fpmarkdown.Default(),
	}
}
